web/apps/utilisateur/urls.py
from django.contrib.auth import views as auth_views
from django.urls import path

from .forms import ConnexionForm
from .views import deconnexion, reset_complete, \
    admin_user, user_view, password_change, user_info_change, admin_all_users, \
    admin_delete_user, all_users, \
    public_profile, get_user_cgu_consent, get_user_inscription, \
    get_user_profile_picture, nom_oublie, inscription, PasswordResetView, \
    valider, valider_cotisation, administrators, accept_cgu, download_user_list


urlpatterns = [
    path('', user_view, name='utilisateur'),
    path('nom_d_utilisateur/', nom_oublie, name="username"),
    path('inscription/fiche/<int:user_id>', get_user_inscription,
         name="fiche_inscription"),
    path('photo/<int:user_id>', get_user_profile_picture,
         name="photo_utilisateur"),
    path('cgu/accept/', accept_cgu, name="cgu_accept"),
    path('cgu/fiche/<int:user_id>', get_user_cgu_consent, name="fiche_cgu"),
    path('tous/admin/', admin_all_users, name="admin_all_users"),
    path('tous/admin/download', download_user_list, name="download_user_list"),
    path('bureaux/', administrators, name="administrators"),
    path('tous/', all_users, name="all_users"),
    path('<int:uuid>/public/', public_profile, name="public_profile"),
    path('modification/<int:uuid>', admin_user, name="admin_user"),
    path('suppression/<int:uuid>', admin_delete_user,
         name="admin_delete_user"),
    path('inscription/', inscription, name='inscription'),
    path('modification/', user_info_change, name='modification_compte'),
    path('connexion/',
         auth_views.LoginView.as_view(authentication_form=ConnexionForm),
         name='connexion'),
    path('deconnexion/', deconnexion, name='deconnexion'),
    path('mot_de_passe/', password_change, name='modification_mot_de_passe'),
    path('mot_de_passe/reinitialisation/', PasswordResetView.as_view(),
         {'post_reset_redirect': '/#/login?resetemail=true'},
         name="password_reset"),
    path('mot_de_passe/reinitialisation/ok/',
         auth_views.PasswordResetDoneView.as_view(),
         name='password_reset_done'),
    path('mot_de_passe/reinitialisation/confirmation/<uidb64>/<token>',
         auth_views.PasswordResetConfirmView.as_view(),
         name='password_reset_confirm'),
    path('mot_de_passe/reinitialisation/fini', reset_complete,
         name='password_reset_complete'),
    path('valider/<int:uuid>/<int:groupid>', valider,
         name='valider_utilisateur'),
    path('cotisation/<int:uuid>/<str:cotisid>', valider_cotisation,
         name='valider_cotisation'),
]

web/intramwet/urls.py
from django.conf import settings
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('intramwet.core.urls')),
    path('admin/', admin.site.urls),
    path('django-rq/', include('django_rq.urls'))
]

# Sentry testing
if settings.DEBUG:
    def trigger_error(request):
        division_by_zero = 1 / 0

    urlpatterns += path('sentry-debug/', trigger_error),

web/apps/utilisateur/models.py
import os
from datetime import datetime, timezone, date
from tempfile import TemporaryFile
from typing import List

from django.contrib.auth.models import AbstractUser, Group, Permission, UserManager
from django.core.validators import RegexValidator
from django.db import models
from django.db.models import Q
from django.db.models.signals import post_save
from django.dispatch import receiver
from django.template.loader import render_to_string
from django.templatetags.static import static
from django.utils.functional import cached_property
from django_extensions.db.models import TimeStampedModel
from icalendar import vCalAddress, vText
from xhtml2pdf import pisa

from apps.conf.views import get_cgu_text


class UtilisateurManager(UserManager):
    def reset_has_read_cgu(self):
        for user in self.all():
            user.has_read_cgu = False
            user.save()


class Utilisateur(AbstractUser):
    anniversaire = models.DateField(
        'anniversaire',
        null=True,
        blank=True
    )
    adresse = models.TextField(
        'adresse',
        max_length=200,
        null=True,
        blank=True
    )
    numeroDeTelephoneRegex = RegexValidator(
        regex=r'^\+?1?\d{9,15}$',
        message="Le numéro de téléphone doit être entré au format '+999999999'. 15 chiffres maximum."
    )
    numeroDeTelephone = models.CharField(
        'numéro de téléphone',
        validators=[numeroDeTelephoneRegex],
        max_length=17,
        null=True,
        blank=True
    )
    photo = models.ImageField(
        upload_to='photos_utilisateurs/',
        blank=True,
        null=True
    )
    montantCaution = models.IntegerField(
        'montant de la caution',
        default=0
    )
    numeroChequeDeCaution = models.IntegerField(
        'numero de cheque',
        blank=True,
        null=True
    )
    has_read_cgu = models.BooleanField(
        "Si l'utilisateur a accepté les CGU sur la période courante",
        default=False
    )
    valide = models.BooleanField(
        "membre validé par le bureau",
        default=False
    )
    actif = models.BooleanField(
        "membre actif pour l'année",
        default=True
    )

    NON_PAYEE = "ATT"
    PAYEE_ESP = "PES"
    PAYEE_CHQ = "PCH"
    PAYEE_VIR = "PVI"
    NON_NECESSAIRE = "INU"
    statutCotisation = models.CharField(
        max_length=3,
        choices=[
            (NON_PAYEE, "Non payée"),
            (PAYEE_ESP, "Payée en espèces"),
            (PAYEE_CHQ, "Payée par chèque"),
            (PAYEE_VIR, "Payée par virement"),
            (NON_NECESSAIRE, "Non nécessaire"),
        ],
        default=NON_NECESSAIRE,
    )

    organisation = models.ForeignKey(
        'treso.Client',
        on_delete=models.PROTECT,
        null=True,
        blank=True,
        related_name='utilisateurs'
    )

    objects = UtilisateurManager()

    def __str__(self):
        return "%s %s @%s" % (self.first_name, self.last_name, self.username)

    @cached_property
    def nomComplet(self):
        return "%s %s" % (self.first_name, self.last_name)

    @cached_property
    def photo_url(self):
        return self.photo.url if self.photo else static(
            'utilisateur/images/default-user.png')

    @cached_property
    def ficheInscription(self):
        today = datetime.now(timezone.utc)
        year = int(today.strftime('%Y'))
        if today.month < 9:
            debut = datetime(year=year - 1, month=9, day=1)
            fin = datetime(year=year, month=8, day=31, hour=23, minute=59,
                           second=59)
        else:
            debut = datetime(year=year, month=9, day=1)
            fin = datetime(year=year + 1, month=8, day=31, hour=23, minute=59,
                           second=59)
        return self.fichesInscription.all().filter(date__lt=fin,
                                                   date__gte=debut).order_by(
            '-date').first()

    @cached_property
    def vCalAddress(self):
        utilisateur = vCalAddress(f'MAILTO:{self.email}')
        utilisateur.params['cn'] = vText(self.nomComplet)
        return utilisateur

    @property
    def montant_cotisation(self) -> int:
        if self.statutCotisation != self.NON_NECESSAIRE:
            return CotisationGroupe.objects.get_for_user(user=self).cotisation
        return 0

    class Meta:
        permissions = (
            ('acceder_materiel', 'Peut accéder à la page materiel'),
            ('acceder_local', 'Peut accéder à la page d\'emprunt du local'),
            ('acceder_projets', 'Peut accéder à la page projets'),
            ('acceder_passation', "Peut accéder à l'interface de passation."),
            ('acceder_membres', "Peut accéder au module membres."),
            ('acceder_treso', "Peut accéder au module de tréso."),
            ('acceder_wiki', "Peut accéder au module wiki."),
            ('fiche_inscription',
             'Doit générer une fiche d\'inscription à la validation'),
            ('represente_organisation',
             'Peut représenter un client de l\'association'),
            ('acceder_demande_ndf', "Peut accéder à l'interface de saisie de note de frais."),
            ('recevoir_notification_demande_ndf', "Reçoit des notifications lorsqu'une nouvelle demande de note de frais est générée"),
            ('recevoir_notification_emprunt',
             "Reçoit des notifications lorsqu'une nouvelle demande d'emprunt est créée"),
            ('recevoir_notification_projet',
             "Reçoit des notifications lorsqu'un nouveau projet est créé")
        )


class StatutCA(models.Model):
    statut = models.CharField("Statut du membre au Conseil d'administration",
                              max_length=200)
    unique = models.BooleanField("Statut unique du poste CA", default=False)
    acceder_passation = models.BooleanField("Ce statut donne accès à l'interface de passation", default=False)
    acceder_treso = models.BooleanField("Ce statut donne accès à la tréso", default=False)
    acceder_su = models.BooleanField("Ce statut donne un accès super-utilisateur", default=False)
    notifications_projet = models.BooleanField("Ce statut est informé pour la création de nouveaux projets", default=False)
    notifications_emprunt = models.BooleanField("Ce statut est informé pour la création de nouveaux emprunts",
                                               default=False)

    PRESIDENT = "PRES"
    TRESORIER = "TRES"
    SECRETAIRE = "SECR"
    DEV = "DEV"
    AUTRE = "AUTR"
    GESTIONNAIRE_CINET = "CINT"
    poste = models.CharField(
        max_length=4,
        choices=[
            (PRESIDENT, "Président"),
            (TRESORIER, "Trésorier"),
            (SECRETAIRE, "Sécretaire"),
            (DEV, "Développeur"),
            (AUTRE, "Autre"),
            (GESTIONNAIRE_CINET, "Gestionnaire cinet'")
        ],
        default=AUTRE,
    )

    def __str__(self):
        return "%s" % self.statut


class MandatCAManager(models.Manager):
    def current(self):
        current_cas = self.filter(Q(fin=None) | Q(fin__gt=datetime.today().date()))
        if current_cas:
            return current_cas.latest('id')
        return self.none()


class MandatCA(models.Model):
    debut = models.DateField("Date de début du mandat", auto_now_add=True)
    fin = models.DateField("Date de fin du mandat", null=True, blank=True)
    objects = MandatCAManager()

    @property
    def current(self) -> bool:
        return self.fin is None or self.fin > datetime.today().date()

    def __str__(self):
        return "Bureau actuel" if self.current else f"Du {self.debut} au {self.fin}"


@receiver(post_save, sender=MandatCA)
def remove_admin_rights_for_old_members(sender, instance: MandatCA,
                                        created: bool, **kwargs):
    for m in instance.membresCA.all():
        m.save(force_update=True)


class MembreCAManager(models.Manager):
    def emails_for_permission(self, permission_codename: str):
        perm = Permission.objects.get(codename=permission_codename)
        curr_mandat = MandatCA.objects.current()
        queryset = self.filter(mandat=curr_mandat) if curr_mandat else self
        emails_tuple_list = queryset.filter(
            Q(membre__groups__permissions=perm) | Q(membre__user_permissions=perm)).distinct().values_list(
            'membre__email')
        if emails_tuple_list:
            emails = [e[0] for e in
                      emails_tuple_list]  # django's values_list method returns a (email,) tuple for each entry, converting to list
            return list(set(emails))  # returning unique emails
        return []

    def emails_to_notify_for_emprunt(self) -> List[str]:
        return self.emails_for_permission('recevoir_notification_emprunt')

    def emails_to_notify_for_projet(self) -> List[str]:
        return self.emails_for_permission('recevoir_notification_projet')

    def emails_to_notify_for_ndf(self) -> List[str]:
        return self.emails_for_permission('recevoir_notification_demande_ndf')


class MembreCA(models.Model):
    statut = models.ForeignKey(StatutCA, on_delete=models.PROTECT)
    membre = models.ForeignKey(Utilisateur, on_delete=models.CASCADE,
                               related_name="postesCA")
    mandat = models.ForeignKey(MandatCA, on_delete=models.CASCADE,
                               related_name="membresCA")
    objects = MembreCAManager()

    @property
    def current(self) -> bool:
        return self.mandat.current

    @cached_property
    def notification_ndf(self) -> bool:
        return self.membre.has_perm('utilisateur.recevoir_notification_demande_ndf')

    def set_admin_rights(self, save: bool = True):
        self.membre.is_staff = True
        self.membre.is_superuser = self.statut.acceder_su
        permission_codenames = []
        if self.statut.acceder_passation:
            permission_codenames.append('acceder_passation')
        if self.statut.acceder_treso:

web/apps/utilisateur/templates/accept_cgu.html
{% load widget_tweaks %}

<!-- Modal -->
<div id="myModal" class="modal fade" role="dialog" data-backdrop="static" data-keyboard="false">
    <div class="modal-dialog">

        <!-- Modal content-->
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Conditions d'utilisation</h4>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
                <p>Pour assurer le fonctionnement de l'association, {{ NAME }} doit récolter certaines
                    données, dont votre <strong>nom, prénom, date de naissance, adresse postale, adresse
                        mail et numéro de téléphone</strong>. Ces données sont utilisées pour la
                    communication
                    interne de l'association, ainsi que pour différents documents administratifs. Vous
                    trouverez plus de détails sur vos droits et l'utilisation de vos données dans les
                    conditions générales d'utilisation. Pour toute question, adressez-vous à <a
                            href="mailto:{{ SUPPORT_EMAIL }}?Subject=Confidentialité" target="_top">{{ SUPPORT_EMAIL }}</a>.
                </p>
                    <div class="form-group form-check">
                        {% render_field form.has_accepted_cgu class="form-check-input" %}
                        <label for="{{ form.has_accepted_cgu.html_name }}" class="form-check-label">
                            <p> J'ai lu et j'accepte les <a href="{% url 'cgu' %}" target="_blank">conditions générales d'utilisation</a>.</p>
                        </label>
                    </div>
                    <div class="form-group form-check">
                        {% render_field form.has_accepted_rgpd class="form-check-input" %}
                        <label for="{{ form.has_accepted_rgpd.html_name }}" class="form-check-label">
                            <p> J'ai lu et j'accepte la politique de confidentialité.</p>
                        </label>
                    </div>
                    <div class="form-group form-check">
                        {% render_field form.has_accepted_cookies class="form-check-input" %}
                        <label for="{{ form.has_accepted_rgpd.has_accepted_cookies }}" class="form-check-label">
                            <p> J'accepte l'utilisation de cookies.</p>
                        </label>
                    </div>
            </div>
            <div class="modal-footer">
                <button id="btn-tos" type="button" onclick="acceptCGU()" class="btn btn-primary">Suivant</button>
            </div>
        </div>

    </div>
</div>

web/apps/utilisateur/templates/all_users.html
{% extends 'utilisateur.html' %}
{% load static %}

{% block title %}
    Utilisateurs
{% endblock %}

{% block head_css %}
    <link href="{% static 'utilisateur/css/user-profiles-list-basic.css' %}"
          rel="stylesheet" media="screen">
{% endblock %}

{% block footer_javascript %}
    <script src="https://cdn.jsdelivr.net/npm/bootstrap-confirmation2@4.0.0/dist/bootstrap-confirmation.min.js"></script>
    <script src="{% static 'utilisateur/js/userSearch.js' %}?v=1"></script>
    <script>
        $('.switch').click(function () {
            $(this).find('i').toggleClass("fa-angle-right fa-angle-down");
        });
        $('#searchbar').on('input', (e) => {
            search(e.target.value.toLowerCase())
        });
    </script>
{% endblock %}

{% block content %}
    <header>
        <h1>Utilisateurs</h1>
    </header>

    <div class="card">
        <div class="card-body">
            <input id="searchbar" name="searchbar" class="form-control"
                   type="text" placeholder="Rechercher un utilisateur..."/>
            <ul id="searchbar-results" class="user-profiles-list-basic"></ul>

        </div>
    </div>

    <div class="card">
        <div class="card-body">
            {% regroup users by groups.first as groups_list %}
            {% for group in groups_list %}
                <a class="switch" data-toggle="collapse"
                   data-target="#{{ group.grouper }}"><i
                        class="fas fa-angle-right"></i> {{ group.grouper }}
                    ({{ group.list|length }})</a>
                <hr>
                <div id="{{ group.grouper }}"
                     class="collapse">
                    <ul class="user-profiles-list-basic">
                        {% for user in group.list %}
                            <li class="user-card">
                                <a href="{% url "photo_utilisateur" user.id %}"
                                   class="user-avatar">
                                    <img src="{% url "photo_utilisateur" user.id %}"
                                         width="80" alt="Profile picture"/>
                                </a>

                                <p class="user-info">
                                    <a href="{% url 'public_profile' uuid=user.id %}"
                                       class="user-fullName">{{ user.nomComplet }}</a>
                                    <span>
                                        <strong class="user-username">{{ user.username }}</strong>
                                        <strong class="user-statutCA">
                                            {% for p in user.postesCA.all %}
                                                {% if p.current %}
                                                     · {{ p.statut }}
                                                {% endif %}
                                            {% endfor %}
                                        </strong>
                                    </span>
                                    <span>Vu le <i>{{ user.last_login }}</i></span>
                                </p>
                            </li>
                        {% endfor %}
                    </ul>
                </div>
            {% endfor %}
        </div>
    </div>
{% endblock %}

web/apps/utilisateur/templates/profil.html
{% extends 'utilisateur.html' %}
{% load static %}

{% block title %}
    Mon profil
{% endblock %}

{% block head_css %}
    <link href="{% static 'utilisateur/css/profile.css' %}"
          rel="stylesheet" media="screen">
{% endblock %}

{% block footer_javascript %}
    <script src="{% static 'utilisateur/js/profile.js' %}"></script>
{% endblock %}

{% block content %}
    <header>
        <h1>Mon profil</h1>
    </header>

    <div class="container-fluid" style="margin-bottom: 50px;">
        <div class="row">
            <div class="col-xl-3 col-lg-5 col-md-5 order-md-12">
                <div class="card card-lg" id="user-info-card">
                    <h5 class="card-header">{{ user.nomComplet }}</h5>
                    <img alt="" src="{% url "photo_utilisateur" user.id %}" class="card-img-top">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-12">
                                <table class="table table-user-information">
                                    <tbody>

                                    <tr>
                                        <td>Nom d'utilisateur:</td>
                                        <td>{{ user.username }}</td>
                                    </tr>

                                    <tr>
                                        <td>Anniversaire:</td>
                                        <td>{{ user.anniversaire }}</td>
                                    </tr>
                                    <tr>
                                        <td>Groupes:</td>
                                        <td>
                                            {% for group in user.groups.all %}
                                                {{ group }}
                                            {% endfor %}
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>Caution déposée:</td>
                                        <td>{{ user.montantCaution }} €</td>
                                    </tr>
                                    <tr>
                                        <td>Cotisation:</td>
                                        <td>{{ user.get_statutCotisation_display }}</td>
                                    </tr>
                                    </tbody>
                                </table>
                                {% if user.ficheInscription %}
                                    <a class="btn btn-primary" target="_blank"
                                       href="{% url "fiche_inscription" user.id %}" style="color:white;">Consulter ma
                                        fiche d'inscription</a>
                                {% endif %}
                                {% if user.acceptationCGU.exists %}
                                    <a class="btn btn-dark" target="_blank" href="{% url "fiche_cgu" user.id %}"
                                       style="color:white;">Dernière fiche CGU</a>
                                {% endif %}
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="col-xl-9 col-lg-7 col-md-7 order-md-1">
                <div class="card card-lg" id="info-card">
                    <h5 class="card-header">Informations personnelles</h5>
                    <div class="card-body">
                        <form method="post" action="{% url 'modification_compte' %}" accept-charset="UTF-8"
                              enctype="multipart/form-data">
                            {% csrf_token %}

                            {{ info_form.non_field_errors }}

                            <div class="form-group">
                                {{ info_form.email.errors }}
                                <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text"><h7><i
                                                class="fas fa-envelope"></i> Email</h7></span>
                                    </div>
                                    <input type="email" class="form-control" id="{{ info_form.email.id_for_label }}"
                                           name="{{ info_form.email.html_name }}"
                                           placeholder="{{ info_form.email.label }}"
                                           value="{{ info_form.email.value }}" required>
                                </div>
                            </div>


                            <div class="form-group">
                                {{ info_form.numeroDeTelephone.errors }}
                                <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text"><h7><i class="fas fa-mobile"></i> Téléphone</h7></span>
                                    </div>
                                    <input type="tel" class="form-control"
                                           id="{{ info_form.numeroDeTelephone.id_for_label }}"
                                           name="{{ info_form.numeroDeTelephone.html_name }}"
                                           placeholder="{{ info_form.numeroDeTelephone.label }}"
                                           value="{{ info_form.numeroDeTelephone.value }}" required>
                                </div>
                            </div>


                            <div class="form-group">
                                {{ info_form.adresse.errors }}
                                <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text"><h7><i
                                                class="fas fa-home"></i> Adresse</h7></span>
                                    </div>
                                    <textarea class="form-control" id="{{ info_form.adresse.id_for_label }}"
                                              name="{{ info_form.adresse.html_name }}"
                                              placeholder="{{ info_form.adresse.label }}"
                                              rows="3" required>{{ info_form.adresse.value }}</textarea>
                                </div>
                            </div>

                            <div class="form-group">
                                {{ info_form.photo.errors }}
                                <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text"><h7><i
                                                class="fas fa-camera-retro"></i> Photo</h7></span>
                                    </div>
                                    <input type="file" class="form-control"
                                           id="{{ info_form.photo.id_for_label }}"
                                           name="{{ info_form.photo.html_name }}"
                                           value="{{ info_form.photo.value }}">
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-md-12">
                                    <div class="form-group">
                                        <input type="submit" value="Sauvegarder"
                                               class="btn btn-primary btn-block"/>
                                        <input type="hidden" name="next" value="{{ next }}"/>
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>

                <div class="card card-lg" id="password-card">
                    <h5 class="card-header">Mot de passe</h5>
                    <div class="card-body">
                        <form method="post" action="{% url 'modification_mot_de_passe' %}" accept-charset="UTF-8">

                            {% csrf_token %}
                            {{ password_form.non_field_errors }}

                            <div class="form-group">
                                {{ password_form.old_password.errors }}
                                <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text"><h7><i class="fas fa-key"></i> Actuel</h7></span>
                                    </div>
                                    <input type="password" class="form-control"
                                           id="{{ password_form.old_password.id_for_label }}"
                                           name="{{ password_form.old_password.html_name }}"
                                           placeholder="Mot de passe actuel" required>
                                </div>
                            </div>

                            <div class="form-group">
                                {{ password_form.new_password1.errors }}
                                <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text"><h7><i
                                                class="fas fa-key"></i> Nouveau</h7></span>
                                    </div>
                                    <input type="password" class="form-control has-popover"
                                           id="{{ password_form.new_password1.id_for_label }}"
                                           name="{{ password_form.new_password1.html_name }}"
                                           placeholder="Nouveau mot de passe" data-toggle="popover"
                                           data-container="body"
                                           data-html="true" data-placement="top"
                                           data-content="{{ password_form.new_password1.help_text|safe }}" required>
                                </div>
                            </div>

                            <div class="form-group">
                                {{ password_form.new_password2.errors }}
                                <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text"><h7><i class="fas fa-key"></i> Confirmation</h7></span>
                                    </div>
                                    <input type="password" class="form-control has-popover"
                                           id="{{ password_form.new_password2.id_for_label }}"
                                           name="{{ password_form.new_password2.html_name }}"
                                           placeholder="Confirmez votre nouveau mot de passe" required>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-md-12">
                                    <div class="form-group">
                                        <input type="submit" value="Changer mon mot de passe"
                                               class="btn btn-primary btn-block"/>
                                        <input type="hidden" name="next" value="{{ next }}"/>
                                    </div>
                                </div>
                            </div>

                        </form>
                    </div>
                </div>
            </div>


        </div>


    </div>





{% endblock %}

web/apps/utilisateur/templates/utilisateur.html
{% extends "base_navbar.html" %}

{% block navbar_compte %}
    active
{% endblock %}